// File: loader.h

// This encapsulates the OGL D3D FILTER As an object

#include <windows.h>
#include <atlbase.h>
#include <stdio.h>
#include <Streams.h>
#include <dshow.h>
#include <commctrl.h>
#include <gl\gl.h>
#include <gl\glu.h>


class CMoviePlayer {
public:
    CMoviePlayer( );
    ~CMoviePlayer();
    HRESULT Initialize();
    void CheckMovieStatus(void);
    void Control(int);
    HRESULT SetMediaFormat( GUID subtype);
    HRESULT CopyMediaSample( IMediaSample *pSample, LONG lSamplePitch);
    HWND    m_hwnd;         // video window
private:
    // methods
    void Cleanup(void);
    HRESULT BuildMoviePlayerFilterGraph();
    // data
    CCritSec m_cs;
    CComPtr<ICaptureGraphBuilder2>  m_pCG;          // Helps to render capture graphs
    CComPtr<IGraphBuilder>          m_pGB;          // GraphBuilder object
    CComPtr<IMediaControl>          m_pMC;          // Media Control
    CComPtr<IMediaEvent>            m_pME;          // Media Event
    CComPtr<IMediaSeeking>          m_pMS;          // Media Seeking
    CComPtr<IMediaPosition>         m_pMP;          // Media Position
    CComPtr<IMediaFilter>           m_pMF;          // Media Filter
};

