// File: movie.cpp

#define _WIN32_DCOM 

#include "master.h"
#include "resource.h"
#include "resrc1.h"

#pragma warning( disable : 4100 4238)

#define CLASSNAME     TEXT("MoviePlayer1")

extern BOOL open_comms(void);
extern void close_comms(void);
extern void RunMovie(HWND);
extern void StopMovie(); // kill it 
extern void ControlMovie(int);
extern HRESULT InitDShowRendererD3D();

extern char MediaFile[];
extern BOOL  FullScreen;     // default NO
extern BOOL  bStereo;       // default NO


extern HWND DisplayEntry(HINSTANCE hInstance, HWND hWndParent);
extern void DisplayClose(HINSTANCE hInstance, HWND hWnd);
extern INT WinD3D(HINSTANCE hInst);

HINSTANCE               hInstance  = 0;
unsigned char           *ScreenL=NULL;
unsigned char           *ScreenR=NULL;
long                    X=0,Y=0;
char                    ExternalImage[255];

static HWND             hWndMain = NULL;
static HWND             hWndDisplay = NULL;

// Function prototypes
LRESULT CALLBACK AboutDlgProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);
LRESULT WINAPI MsgProc( HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam );
BOOL GetOpenFileNameRSF(char *filename, HINSTANCE hInst, char *filter, char *szTitle);
static PSTR FileInPath(PSTR);

int  WhatIsFileType(char *filename);
static void ReleaseImage(void);

LRESULT CALLBACK AboutDlgProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam){
    switch (message){
        case WM_INITDIALOG:
            return TRUE;
        case WM_COMMAND:
            if (wParam == IDOK){
                EndDialog(hWnd, TRUE);
                return TRUE;
            }
            break;
    }
    return FALSE;
}

//INT WINAPI GLmain(HINSTANCE hInst){
INT WINAPI WinMain( HINSTANCE hInst, HINSTANCE hInstPrev, LPSTR lpCmdLine, INT nCmdShow){
    BOOL bShowDisplay=FALSE;
    HRESULT hr = S_OK;
    hInstance = hInst;
    char filen[64];
    CoInitialize (NULL);
    WNDCLASSEX wc = { sizeof(WNDCLASSEX), CS_CLASSDC, MsgProc, 0L, 0L,
                      GetModuleHandle(NULL), 
                      LoadIcon(hInstance, MAKEINTRESOURCE(IDI_TEXTURES)), 
                      NULL,(HBRUSH)GetStockObject(WHITE_BRUSH), 
                      MAKEINTRESOURCE(IDR_MENU),
                      CLASSNAME, NULL };
    RegisterClassEx( &wc );
    hWndMain = CreateWindow( CLASSNAME, CLASSNAME,
                           WS_OVERLAPPEDWINDOW, 50, 50, 350, 80,
                           GetDesktopWindow(), NULL, wc.hInstance, NULL );
    HMENU hMenuMain = GetSystemMenu(hWndMain, FALSE);
    BOOL rc = AppendMenu(hMenuMain, MF_SEPARATOR, 0, NULL);
    rc = AppendMenu(hMenuMain, MF_STRING | MF_ENABLED, 
                    ID_HELP_ABOUT, 
                    TEXT("About Master ...\0"));
    ShowWindow( hWndMain, SW_SHOWDEFAULT );
    UpdateWindow( hWndMain );
    MSG msg;
    ZeroMemory( &msg, sizeof(msg) );
    if(bShowDisplay)PostMessage(hWndMain,WM_COMMAND,ID_CONTROL_STARTDISPLAY,0);
    while(1){
     if(PeekMessage(&msg,NULL,0,0,PM_NOREMOVE)){
        GetMessage(&msg,NULL,0,0);
        if(msg.message == WM_QUIT)break;
        TranslateMessage(&msg);
        DispatchMessage(&msg);
     }
     else{
       Sleep(0);
     }
    }
    if(ScreenL != NULL)free(ScreenL); ScreenL=NULL; ScreenR=NULL;
    UnregisterClass( CLASSNAME, hInstance );
    CoUninitialize();
    return 0L;
}

LRESULT WINAPI MsgProc( HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam ){
    switch( msg )    {
       case WM_PAINT:{
              HDC hDC;
              PAINTSTRUCT  ps;
              hDC = BeginPaint(hWnd, &ps);
              char strx[]="Stereo Movie Master Player";
              TextOut(hDC,5,4,strx,strlen(strx));
              EndPaint(hWnd, &ps);
            }
            break;
		case WM_DESTROY:
			PostQuitMessage( 0 );
            return 0;
        case WM_CHAR:        {
              if (wParam == VK_ESCAPE){
                PostMessage(hWnd, WM_CLOSE, 0, 0);
              }
            }
            break;
        case WM_SYSCOMMAND: {
            char filename[255]="";
            switch (wParam){
                case ID_HELP_ABOUT:
                    CreateDialog(hInstance, MAKEINTRESOURCE(IDD_ABOUTBOX), hWnd, 
                                (DLGPROC) AboutDlgProc);
                    return 0;
                case ID_NOSHOW:
                    if(GetOpenFileNameRSF(filename,hInstance,
                       "All file formats\0*.avi;*.mpg\0"
                       "(*.AVI)\0*.avi\0"
                       "(*.MPG)\0*.mpg\0\0",
                       "Choose Movie File")){
                      int type=WhatIsFileType(filename);
                      ReleaseImage();
                      if(type == FI_AVI){
                        strcpy(MediaFile,filename);
                        RunMovie(hWnd);
                       }    
                    }
                    return 0;
            }
          }
          break;
        case WM_COMMAND:
            if (wParam == ID_FILE_QUIT){
              PostQuitMessage(0);
            }
            else if(wParam == ID_CONTROL_STEREO){
              bStereo ^= 1;
              if(bStereo)CheckMenuItem(GetMenu(hWnd),ID_CONTROL_STEREO,MF_BYCOMMAND|MF_CHECKED);
              else       CheckMenuItem(GetMenu(hWnd),ID_CONTROL_STEREO,MF_BYCOMMAND|MF_UNCHECKED);
            }
            else if(wParam == ID_CONTROL_FULLSCREEN){
              FullScreen ^= 1;
              if(FullScreen)CheckMenuItem(GetMenu(hWnd),ID_CONTROL_FULLSCREEN,MF_BYCOMMAND|MF_CHECKED);
              else          CheckMenuItem(GetMenu(hWnd),ID_CONTROL_FULLSCREEN,MF_BYCOMMAND|MF_UNCHECKED);
            }
            else if(wParam == ID_CONTROL_STARTDISPLAY){
               if(hWndDisplay == NULL){
                 CheckMenuItem(GetMenu(hWnd),ID_CONTROL_STARTDISPLAY,MF_BYCOMMAND|MF_CHECKED);
                 hWndDisplay=DisplayEntry(hInstance,hWnd);
               }
               else{
                 CheckMenuItem(GetMenu(hWnd),ID_CONTROL_STARTDISPLAY,MF_BYCOMMAND|MF_UNCHECKED);
                 DisplayClose(hInstance,hWndDisplay);
                 hWndDisplay=NULL;
               }
            }
            else if(wParam == ID_NOSHOW || wParam == ID_SEQUENCE){
              PostMessage(hWnd,WM_SYSCOMMAND,WPARAM(wParam),0);
            }
            else if(wParam == ID_CONTROL_STARTMOVIE)ControlMovie(0);
            else if(wParam == ID_CONTROL_STOPMOVIE)ControlMovie(2);
            else if(wParam == ID_CONTROL_RESTART)ControlMovie(3);
            else if(wParam == ID_CONTROL_KILLMOVIE)StopMovie();
            else if(wParam == ID_CONTROL_STARTD3D)WinD3D(hInstance);
            else if(wParam == ID_CONTROL_PLAYD3DMOVIE)InitDShowRendererD3D();
            break;
    }
    return DefWindowProc( hWnd, msg, wParam, lParam );
}

static void ReleaseImage(void){
 X=Y=0;
 if(ScreenL != NULL)free(ScreenL); ScreenL=NULL; ScreenR = NULL;
}

int WhatIsFileType(char *filename){
 char CurrentFile[256];
 int ff=FI_XXX;
 strcpy(CurrentFile,filename);
 if     (strstr(CurrentFile,".AVI") || strstr(CurrentFile,".avi"))ff=FI_AVI;
 else if(strstr(CurrentFile,".MPG") || strstr(CurrentFile,".mpg"))ff=FI_MPG;
 return ff;
}

static PSTR FileInPath(PSTR pstrPath){
 PSTR pstr;
 pstr = pstrPath + strlen(pstrPath);
 while (pstr > pstrPath) {
     pstr = (AnsiPrev(pstrPath, pstr));
     if (*pstr == '\\' || *pstr == ':' || *pstr == '/') {
         pstr = (AnsiNext(pstr));
         break;
     }
 }
 return pstr;
}

BOOL GetOpenFileNameRSF(char *filename, HINSTANCE hInst, char *filter, char *szTitle){
 static BOOL bFirstTime=TRUE;
 static char CurrentDirFile[256];
 static char CurrentFile[512]="";
 OPENFILENAME ofn;
 if(bFirstTime){
   GetModuleFileName(hInst,CurrentDirFile,255);
   *(FileInPath(CurrentDirFile)-1) = '\0';
   bFirstTime=FALSE;
 }
 memset(&ofn,0,sizeof(OPENFILENAME));
 ofn.lStructSize=sizeof(OPENFILENAME);
 ofn.hwndOwner=NULL;
 ofn.nFilterIndex=1;
 ofn.lpstrFilter=filter;
 ofn.lpstrFile=CurrentFile;   /* will contain file + path */
 ofn.nMaxFile=sizeof(CurrentFile);
 ofn.lpstrInitialDir=CurrentDirFile;
 ofn.lpstrTitle=szTitle;
 if(GetOpenFileName(&ofn)){
   strcpy(filename,ofn.lpstrFile);
   return TRUE;
 }
 return FALSE;
}
